%global momorel   1
%global pyqtrel   2
%global siprel    2
%global qtrubyrel 1
%global kdever    3.4.1
%global pyqtver   3.13
%global sipver    4.1.1
%global qtrubyver 1.0.9

%global ruby_libdir %(ruby -rrbconfig -e 'puts Config::CONFIG["rubylibdir"]')
%global ruby_archdir %(ruby -rrbconfig -e 'puts Config::CONFIG["archdir"]')

%global qtdir %{_libdir}/qt3
%global qtver 3.3.4
%global kdedir /usr
%global kdelibsrel 1m
%global ftpdirver %{kdever}
%global sourcedir stable/%{ftpdirver}/src

## stil need fix to build java -> disable java at the moment
##global support_arch %{ix86} alpha ia64 ppc
%global support_arch none

Name: kdebindings
Summary: KDE bindings to non-C++ languages
Version: %{kdever}
Release: %{momorel}m
Group: User Interface/Desktops
License: GPL
URL: http://developer.kde.org/language-bindings/
%NoSource 0 ftp://ftp.kde.org/pub/kde/%{sourcedir}/%{name}-%{version}.tar.bz2 18a4e2c42d34bb86279e691498482951
## mirror site in Japan.
#%%NoSource 0 ftp://ftp.kde.gr.jp/pub/kde/%{sourcedir}/%{name}-%{version}.tar.bz2 18a4e2c42d34bb86279e691498482951
Patch1: kdebindings-3.4.0-rbkconfig_compiler-Makefile.patch
Patch4: kdebindings-3.1-ssl-krb5.patch
Patch6: kdebindings-3.4.0-python2.3.patch
Patch7: kdebindings-3.3.2-python-lib64.patch
Patch8: kdebindings-3.3.2-libdir.patch
Patch9: kdebindings-3.3.92-xdg.patch
BuildRoot: %{_tmppath}/%{name}-%{version}-root
Obsoletes: %{name}-perl, %{name}-python
Requires: kdebase >= %{kdever}
Requires: sip, PyQt, qtruby
BuildPreReq: zlib-devel
BuildPreReq: qt-devel >= %{qtver}
BuildPreReq: qscintilla-devel
BuildPreReq: kdelibs-devel >= %{kdever}
BuildPreReq: arts-devel
BuildPreReq: libjpeg-devel
BuildPreReq: libpng-devel >= 1.2.0
BuildPreReq: automake
BuildPreReq: autoconf >= 2.56-3m
BuildPreReq: perl
BuildPreReq: python >= 2.3
BuildPreReq: fam-devel
BuildPreReq: coreutils >= 5.0-1m
BuildPreReq: ruby
BuildConflicts: mono
ExcludeArch: sparc ia64

%description
KDE/DCOP bindings to non-C++ languages, including

  dcopc: DCOP bindings for C
  dcopperl: DCOP bindings for Perl
  dcoppython: DCOP bindings for Python (broken)
  xparts: allows you to embed non-KDE apps as a KPart
  PyKDE: Python bindings to KDE (http://www.riverbankcomputing.co.uk/pykde/)
  Korundum: Ruby bindings to KDE (http://developer.kde.org/language-bindings/ruby/)

 Notice: JAVA(dcopjava,qtjava,kdejava) and C#(qtsharp) bindings are not included.

 Notice: sip, PyQt, and QtRuby are separated to subpackages.

%package devel
Summary: Development files for %{name}
Group: Development/Libraries
Requires: %{name} = %{version}

%description devel
Development files for the KDE bindings.

Install %{name}-devel if you want to develop non-KDE
applications that talk to KDE.

%ifarch %{support_arch}
%package qtjava
Summary: Java bindings to Qt
Group: System Environment/Libraries
Requires: qt >= %{qtver}, libgcj

%description qtjava
Java bindings to Qt.
%endif

%ifarch %{support_arch}
%package kdejava
Summary: Java bindings to KDE
Group: Development/Libraries
Requires: kdelibs >= %{version}, libgcj

%description kdejava
Java bindings to KDE
%endif

%package -n PyQt
Summary: Python bindings to Qt
Group: System Environment/Libraries
Requires: python >= 2.3
Provides: PyQt-devel
Version: %{pyqtver}
Release: %{pyqtrel}m

%description -n PyQt
These are Python bindings for Qt.

%package -n sip
Summary:  Python/C++ Bindings Generator
Group: Development/Libraries
Requires: python >= 2.3
Provides: sip-devel
Version: %{sipver}
Release: %{siprel}m

%description -n sip
SIP is a tool for generating bindings for C++ classes so that they can be
accessed as normal Python classes.  SIP takes many of its ideas from SWIG but,
because it is specifically designed for C++ and Python, is able to generate
tighter bindings.  SIP is so called because it is a small SWIG.

SIP was originally designed to generate Python bindings for KDE and so has
explicit support for the signal slot mechanism used by the Qt/KDE class
libraries.  However, SIP can be used to generate Python bindings for any C++
class library.

%package -n qtruby
Summary: Ruby bindings to Qt
Group: System Environment/Libraries
Requires: python >= 2.3
Version: %{qtrubyver}
Release: %{qtrubyrel}m

%description -n qtruby
These are Ruby bindings for Qt.

Korundum and QtRuby provide bindings to the KDE and Qt frameworks from within Ruby programs.

You can also find out more about Ruby in general here: ruby-lang.org

Being Smoke-based bindings means that they offer full access to most KDE 3.x and Qt 3.x classes.

Notice: Korundum is in kdebindings package

%prep
%setup -q

%patch1 -p1 -b .Makefile
%patch4 -p1 -b .ssl-krb5
%patch6 -p1 -b .python2
%if %{_lib} == "lib64"
%patch7 -p1 -b .python-lib64~
%endif
%patch8 -p1 -b .libdir~
%patch9 -p1 -b .xdg

%build
export QTDIR=%{qtdir} KDEDIR=%{kdedir} QTLIB=%{qtdir}/lib
export PATH="`pwd`/jdk/bin:$PATH"

export CFLAGS="%{optflags}"
export CXXFLAGS="%{optflags}"

# workaround for ia64, need to be fixed later
%ifarch ia64
export CFLAGS="%{optflags} -O0"
export CXXFLAGS="%{optflags} -O0"
%endif

%ifarch %{support_arch}
export CFLAGS="$CFLAGS `mozilla-config --cflags`"
export CXXFLAGS="$CXXFLAGS `mozilla-config --cflags`"
export CPPFLAGS="$CPPFLAGS `mozilla-config --cflags`"
export LDFLAGS="$LDFLAGS `mozilla-config --libs`"
%endif

# workaround for automake/autoconf version
perl -p -i -e "s|KDE_AUTOCONF_VERS=\"|KDE_AUTOCONF_VERS=\"-2.59 |g" admin/detect-autoconf.sh
perl -p -i -e "s|KDE_AUTOMAKE_VERS=\"|KDE_AUTOMAKE_VERS=\"-1.9|g" admin/detect-autoconf.sh

make -f admin/Makefile.common cvs

suffix=""
%if %{_lib} == "lib64"
suffix="64"
%endif

RUBY_ARCHDIR=%{ruby_archdir} RUBY_SITEARCHDIR=%{ruby_archdir} RUBY_SITEDIR=%{ruby_sitedir} ./configure \
	--prefix=%{_prefix} \
	--libdir=%{_libdir} \
	--mandir=%{_mandir} \
	--sysconfdir=%{_sysconfdir} \
	--includedir=%{_includedir} \
	--enable-libsuffix="$suffix" \
	--with-qt-libraries=%{qtdir}/lib \
	--disable-final \
%ifarch %{support_arch}
	--with-java=%{prefix}
%else
	--without-java
%endif

%make

# make dcopperl
pushd dcopperl
perl Makefile.PL <<EOF
$QTDIR/include
$QTDIR/lib
%{_includedir}
%{_libdir}
EOF
make
popd

# make dcopc
make -C dcopc 

# make xparts
make -C xparts

%install
[ "%{buildroot}" != "/" ] && rm -rf %{buildroot}

export PATH=`pwd`/jdk/bin:$PATH
make install DESTDIR=%{buildroot} RUBY_ARCHDIR=%{ruby_archdir} RUBY_SITEARCHDIR=%{ruby_archdir} RUBY_SITEDIR=%{ruby_libdir}

make -C dcopperl install DESTDIR=%{buildroot}

# install dcopc
make -C dcopc install DESTDIR=%{buildroot}
# install xparts
make -C xparts DESTDIR=%{buildroot} install


if [ -d "%{buildroot}%{_prefix}/doc" ]; then
   mkdir -p %{buildroot}%{_docdir}
   mv -f %{buildroot}%{_prefix}/doc/* $RPM_BUILD_ROOT%{_docdir}
   rm -rf %{buildroot}%{_prefix}/doc
fi

%post -p /sbin/ldconfig

%post -n sip
/sbin/ldconfig

%post -n PyQt
/sbin/ldconfig

%post -n qtruby
/sbin/ldconfig

%postun -p /sbin/ldconfig

%postun -n sip
/sbin/ldconfig

%postun -n PyQt
/sbin/ldconfig

%postun -n qtruby
/sbin/ldconfig

%clean
[ "%{buildroot}" != "/" ] && rm -rf %{buildroot}

%files
%defattr(-,root,root)
%{_bindir}/embedjs
%{_bindir}/jsaccess
%{_bindir}/kjscmd
%{_libdir}/*.so.*
%{_libdir}/kde3/*.la
%{_libdir}/kde3/*.so
%{_datadir}/applications/kde/*.desktop
%{_datadir}/apps/embedjs
%{_datadir}/apps/kate/scripts/*
%{_datadir}/apps/kjsembed
%{_datadir}/icons/*/*/*/*.png
%{_datadir}/services/*.desktop
%{_datadir}/servicetypes/*.desktop
%{_mandir}/man1/kjscmd.1*
# dcopperl
%{_libdir}/perl5/*/*/perllocal.pod
%{_libdir}/perl5/site_perl/*/*/auto/DCOP/*
%{_libdir}/perl5/site_perl/*/*/auto/DCOP/.packlist
%{_libdir}/perl5/site_perl/*/*/DCOP.pm
%{_libdir}/perl5/site_perl/*/*/DCOP/Object.pm
%{_mandir}/man3/DCOP.3pm*
# dcoppython
%{_libdir}/python*/pydcop.py
%{_libdir}/python*/site-packages/pcop.so
%{_libdir}/python*/site-packages/pcop.la
# PyKDE
%{_libdir}/python*/site-packages/dcop.so
%{_libdir}/python*/site-packages/dcopexport.py
%{_libdir}/python*/site-packages/dcopext.py
%{_libdir}/python*/site-packages/kdecore.so
%{_libdir}/python*/site-packages/kdefx.so
%{_libdir}/python*/site-packages/kdeprint.so
%{_libdir}/python*/site-packages/kdesu.so
%{_libdir}/python*/site-packages/kdeui.so
%{_libdir}/python*/site-packages/kfile.so
%{_libdir}/python*/site-packages/khtml.so
%{_libdir}/python*/site-packages/kio.so
%{_libdir}/python*/site-packages/kmdi.so
%{_libdir}/python*/site-packages/kparts.so
%{_libdir}/python*/site-packages/kspell.so
%{_libdir}/python*/site-packages/kutils.so
%{_libdir}/python*/site-packages/pykdeconfig.py
# korundum
%{_bindir}/krubyinit
%{_bindir}/rbkconfig_compiler
%{_bindir}/rbkdeapi
%{_bindir}/rbkdesh
%{ruby_archdir}/korundum*
%{ruby_libdir}/Korundum.rb
%{ruby_libdir}/KDE
# xparts
%{_bindir}/shell_xparthost
%{_bindir}/xp_notepad
%{_includedir}/xkparts
# java
%ifarch %{support_arch}
%{_libdir}/java
%doc %{_docdir}/javalib
%endif

## qtruby
%files -n qtruby
%defattr(-,root,root)
%{_bindir}/qtrubyinit
%{_bindir}/rbqtapi
%{_bindir}/rbqtsh
%{_bindir}/rbuic
%{ruby_archdir}/qtruby*
%{ruby_archdir}/qui*
%{ruby_libdir}/Qt.rb
%{ruby_libdir}/Qt

## sip
%files -n sip
%defattr(-,root,root)
%{_bindir}/sip
%{_libdir}/python*/site-packages/sip*
%{_includedir}/python*/sip.h
%dir %{_datadir}/sip

## PyQt
%files -n PyQt
%defattr(-,root,root)
%{_bindir}/pylupdate
%{_bindir}/pyuic
%{_libdir}/python*/site-packages/qt*.so
%{_libdir}/python*/site-packages/pyqtconfig.py
%{_datadir}/sip/*

%files devel
%defattr(-,root,root)
%{_libdir}/*.la
%{_libdir}/*.so
%{_includedir}/smoke.h
%{_includedir}/kjsembed
%{_includedir}/dcopc

%changelog
* Wed Jun  1 2005 Ichiro Nakai <ichiro@n.email.ne.jp>
- (3.4.1-1m)
- update to KDE 3.4.1
- --disable-final

* Mon Mar 28 2005 Ichiro Nakai <ichiro@n.email.ne.jp>
- (3.4.0-1m)
- update to KDE 3.4.0
- update python(version).patch
- import kdebindings-3.3.92-xdg.patch from Fedora Core
- add kdebindings-3.4.0-rbkconfig_compiler-Makefile.patch

* Sun Mar 20 2005 Mitsuru Shimamura <smbd@momonga-linux.org>
- (3.3.2-4m)
- rebuild against qscintilla-1.5.1

* Tue Feb  8 2005 Dai OKUYAMA <dai@ouchi.nahi.to>
- (3.3.2-3m)
- $(prefix)/lib -> $(libdir)

* Tue Feb  8 2005 Dai OKUYAMA <dai@ouchi.nahi.to>
- (3.3.2-2m)
- enable x86_64.

* Mon Dec 13 2004 Masayuki SANO <nosanosa@momonga-linux.org>
- (3.3.2-1m)
- update to KDE 3.3.2
 
* Mon Oct 18 2004 Masayuki SANO <nosanosa@momonga-linux.org>
- (3.3.1-1m)
- update to KDE 3.3.1
- versions of sip, PyQt and qtruby are 4.0.2-4m, 3.12-4m, 1.0.3-1m respectively
 
* Mon Sep 27 2004 Hiroyuki Koga <kuma@momonga-linux.org>
- (3.3.0-3m)
- rebuild against kdelibs-3.3.0-3m (libstdc++-3.4.1)

* Sun Sep 26 2004 Ichiro Nakai <ichiro@n.email.ne.jp>
- (3.3.0-2m)
- revise %%files section
  %%{_libdir}/*.so* -> %%{_libdir}/*.so.*

* Fri Sep 24 2004 Masayuki SANO <nosanosa@momonga-linux.org>
- (3.3.0-1m)
- KDE 3.3.0
- make sip, PyQt, qtruby subpackages
- add Patch100

* Thu Jun 17 2004 Masayuki SANO <nosanosa@momonga-linux.org>
- (3.2.3-1m)
- KDE 3.2.3
- Bugfix Release
 
* Sat Apr 24 2004 Masayuki SANO <nosanosa@momonga-linux.org>
- (3.2.3-1m)
- KDE 3.2.3

* Tue Mar 23 2004 Toru Hoshina <t@momonga-linux.org>
- (3.2.1-2m)
- revised spec for enabling rpm 4.2.

* Sat Mar 13 2004 Masayuki SANO <nosanosa@momonga-linux.org>
- (3.2.1-1m)
- KDE 3.2.1 Release

* Sat Feb 14 2004 Masayuki SANO <nosanosa@momonga-linux.org>
- (3.2.0-1m)
- KDE 3.2.0
- modified %%files

* Thu Jan 15 2004 YAMAZAKI Makoto <zaki@zakky.org>
- (3.1.5-1m)
- update to 3.1.5

* Fri Dec 26 2003 kourin <kourin@fh.freeserve.ne.jp>
- (3.1.4-4m)
- rebuild against for qt-3.2.3

* Mon Nov 10 2003 kourin <kourin@fh.freeserve.ne.jp>
- (3.1.4-3m)
- rebuild against for qt-3.2.3

* Fri Oct 3 2003 kourin <kourin@fh.freeserve.ne.jp>
- (3.1.4-2m)
- change includedir

* Wed Sep 24 2003 kourin <kourin@fh.freeserve.ne.jp>
- (3.1.4-1m)
- update to 3.1.4

* Wed Aug 13 2003 YAMAZAKI Makoto <uomaster@nifty.com>
- (3.1.3-1m)
- update to 3.1.3

* Mon May 26 2003 YAMAZAKI Makoto <uomaster@nifty.com>
- (3.1.2-1m)
- update to 3.1.2
- delete export _POSIX2_VERSION=199209 and add BuildPreReq: coreutils >= 5.0-1m (for glibc-2.3.2 environment)

* Mon May 12 2003 YAMAZAKI Makoto <uomaster@nifty.com>
- (3.1.1-3m)
- export _POSIX2_VERSION=199209

* Sun Mar 23 2003 Shingo Akagaki <dora@kitty.dnsalias.org>
- (3.1.1-2m)
- rebuild against for XFree86-4.3.0

* Fri Mar 21 2003 YAMAZAKI Makoto <uomaster@nifty.com>
- (3.1.1-1m)
- update to 3.1.1
  Changelog from 3.0.5 to 3.1
    bindings updated.
  Changelog from 3.1 to 3.1.1
    Removing Qt bindings for private interfaces that were accidentally included and now caused compilation failures with Qt 3.1.2.
    Several other build related fixes.
 
* Thu Mar  6 2003 Shingo Akagaki <dora@kitty.dnsalias.org>
- (3.0.5a-2m)
- remove kmozilla

* Sun Jan 12 2003 Tadataka Yoshikawa <yosshy@momonga-linux.org>
- (3.0.5a-1m)
- ver up.

* Wed Dec 11 2002 YAMAZAKI Makoto <uomaster@nifty.com>
- (3.0.4-2m)
- use autoconf-2.53

* Fri Oct 11 2002 Tadataka Yoshikawa <yosshy@momonga-linux.org>
- (3.0.4-1m)
- ver up.

* Mon Aug 19 2002 Tadataka Yoshikawa <yosshy@momonga-linux.org>
- (3.0.3-1m)
- ver up.

* Wed Jul 17 2002 Tadataka Yoshikawa <yosshy@momonga-linux.org>
- (3.0.2-2m)
- rebuild against qt-3.0.5.

* Sun Jul 14 2002 Tadataka Yoshikawa <yosshy@momonga-linux.org>
- (3.0.2-1m)
- ver up.

* Sun Jun  9 2002 Tadataka Yoshikawa <yosshy@kondara.org>
- (3.0.1-2k)
- ver up.

* Thu Apr  4 2002 Toru Hoshina <t@kondara.org>
- (3.0.0-2k)
  update to 3.0 release.

* Sat Feb 23 2002 Shigeru Yamazaki <s@kondara.org>
- (2.2.2-4k)
- rebuild against python 2.2 and mozilla 0.9.8

* Tue Nov 27 2001 Toru Hoshina <t@kondara.org>
- (2.2.2-2k)
- version up.

* Fri Nov  2 2001 Toru Hoshina <t@kondara.org>
- (2.2.1-8k)
- rebuild against mozilla 0.9.5.

* Tue Oct 30 2001 Toru Hoshina <t@kondara.org>
- (2.2.1-6k)
- revised spec file.

* Tue Oct 16 2001 Toru Hoshina <t@kondara.org>
- (2.2.1-4k)
- rebuild against libpng 1.2.0.

* Thu Oct  4 2001 Toru Hoshina <t@kondara.org>
- (2.2.1-2k)
- version up.

* Wed Aug 22 2001 Toru Hoshina <toru@df-usa.com>
- (2.2.0-2k)
- stable release, however still no fam, no python2...

* Sat Aug 11 2001 Toru Hoshina <toru@df-usa.com>
- (2.2.0-0.0003002k)
- based on 2.2beta1.

* Fri Jun  1 2001 Toru Hoshina <toru@df-usa.com>
- (2.2.0-0.0002002k)
- based on 2.2alpha2.

* Sat May 12 2001 Toru Hoshina <toru@df-usa.com>
- (2.2.0-0.0001002k)

* Wed Mar 21 2001 Toru Hoshina <toru@df-usa.com>
- (2.1-2k)

* Wed Feb 28 2001 Trond Eivind Glomsr?<teg@redhat.com>
- rebuild

* Wed Feb 21 2001 Bernhard Rosenkraenzer <bero@redhat.com>
- 2.1

* Sun Jan 28 2001 Bernhard Rosenkraenzer <bero@redhat.com>
- initial RPM
